// The Vue build version to load with the `import` command
// (runtime-only or standalone) has been set in webpack.base.conf with an alias.
import './config.js';
import './util/tools.js';
import Vue from 'vue';
import App from './App';
import router from './router';
import store from './store';
import animated  from 'animate.css'
import ElementUI from 'element-ui';
import $ from 'jquery';
// 引入iview组件
import iView from 'iview';
import 'iview/dist/styles/iview.css';
import uploader from 'vue-simple-uploader';
import NProgress from 'nprogress'; // 进度条
//引入nprogress
import 'nprogress/nprogress.css'; //这个样式必须引入
import '../static/iconfont/iconfont.css';
import { post, get, patch, put, postResponseFile, getItoInterfaceInfo, getItoInterfaceInfo2 } from './util/http';
import VueVirtualScroller from 'vue-virtual-scroller/dist/vue-virtual-scroller.umd.js'
import 'vue-virtual-scroller/dist/vue-virtual-scroller.css'
// import 'lib-flexible'
import classifyOptions from './components/classifyOptions.vue'
import moment from 'moment'
import VueBackTimeLine from 'vue-back-time-line'
import 'vue-back-time-line/lib/back-time-line.css'
import VideoTimeline from '@wanglin1994/video-timeline'
import dataV from '@jiaminghi/data-view'
import "echarts-gl"
import htmlToPdf from '@/util/htmlToPdf.js'
Vue.use(dataV)
Vue.use(htmlToPdf)
Vue.use(VideoTimeline)
Vue.use(VueBackTimeLine)
//定义全局变量
Vue.prototype.$moment = moment;
Vue.prototype.$ = $;
Vue.prototype.$post = post;
Vue.prototype.$postResponseFile = postResponseFile;
Vue.prototype.$get = get;
Vue.prototype.$patch = patch;
Vue.prototype.$put = put;
Vue.prototype.$getItoInterfaceInfo = getItoInterfaceInfo;
Vue.prototype.$getItoInterfaceInfo2 = getItoInterfaceInfo2;

// 引入axios，并加到原型链中
import axios from 'axios';
global.axios = axios; //设置一个全局axios便于调用

// 简单配置
NProgress.inc(0.2);
NProgress.configure({ easing: 'ease', speed: 500, showSpinner: false });

Vue.use(ElementUI);
Vue.use(iView);
Vue.use(uploader);
// Vue.use(VueVirtualScroller)

Vue.component('classifyOptions',classifyOptions)
Vue.component('RecycleScroller', VueVirtualScroller.RecycleScroller)

Vue.config.productionTip = false;
Vue.prototype.$echartsReize = function(ref) {
    window.addEventListener('resize', function() {
        ref.resize();
    });
};
Vue.prototype.setSortNum = function(index, pageNo, pageSize) {
    pageNo = pageNo <= 1 ? 1 : pageNo;
    return (pageNo - 1) * pageSize + (index + 1);
};
Vue.prototype.$dateFormat = function(date) {
    if (date == undefined) {
        return '';
    }
    var year = date.getFullYear();
    var month = date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1;
    var day = date.getDate() < 10 ? '0' + date.getDate() : date.getDate();
    var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();

    return year + '-' + month + '-' + day + ' ' + hours + ':' + minutes + ':' + seconds;
};

//使用钩子函数对路由进行权限跳转
router.beforeEach((to, from, next) => {
    NProgress.start();
    tools.checkVersion(function(data) {
        let versionOld = JSON.parse(sessionStorage.getItem('version') || '{}');
        if (data.version != versionOld.version || data.userVersion != versionOld.userVersion) {
            sessionStorage.setItem('version', JSON.stringify(data));
            JSON.stringify(versionOld) != '{}' && window.location.reload();
        }
    });
    to.meta && to.meta.type == 1 && !to.meta.setimFlag && store.commit('setKeepAliveList', { type: 'add', page: to.name });
    document.title = `${to.meta.title}`;
    const tokey = sessionStorage.getItem('tokey');
    if (!tokey && to.path !== window.routeDir + '/pages/login') {
        if (sessionStorage.getItem('tokey') == null && to.path == window.routeDir + '/pages/gk_install') {
            //判断本地是否存在tokey
            next();
        } else if (sessionStorage.getItem('tokey') == null && to.path == window.routeDir + '/pages/consultation_news') {
            next();
        } else if (sessionStorage.getItem('tokey') == null && to.path == window.routeDir + '/pages/loginZto') {
            next();
        } else if (sessionStorage.getItem('tokey') == null && to.name == 'sb_trail2') {
            next();
        } else {
            next({ path: window.routeDir + '/pages/login' });
        }
    } else if (to.meta.permission) {
        // 如果是管理员权限则可进入，这里只是简单的模拟管理员权限而已
        next();
        // role === 'admin' ? next() : next('/403');
    } else {
        // 简单的判断IE10及以下不进入富文本编辑器，该组件不兼容
        if (navigator.userAgent.indexOf('MSIE') > -1 && to.path === '/editor') {
            Vue.prototype.$alert('vue-quill-editor组件不兼容IE10及以下浏览器，请使用更高版本的浏览器查看', '浏览器不兼容通知', { confirmButtonText: '确定' });
        } else {
            next();
        }
    }

    // 实现外部链接跳转进来获取请求参数
    if (from.path == window.routeDir + '/pages/consultation_news') {
        if (sessionStorage.getItem('tokey') || from.path == window.routeDir + '/pages/consultation_news') {
            if (from.path == window.routeDir + '/pages/consultation_news') {
                next({ path: from.path + '?obligate=' + from.query.obligate });
            } else if (from.path == window.routeDir + '/pages/loginZto') {
                next({ path: from.path + '?code=' + from.query.code + '&' + from.query.source });
            } else {
                next({ path: from.fullPath });
            }
        } else if (to.meta.permission) {
            // 如果是管理员权限则可进入，这里只是简单的模拟管理员权限而已
            next();
        } else {
            // 简单的判断IE10及以下不进入富文本编辑器，该组件不兼容
            if (navigator.userAgent.indexOf('MSIE') > -1 && to.path === '/editor') {
                Vue.prototype.$alert('vue-quill-editor组件不兼容IE10及以下浏览器，请使用更高版本的浏览器查看', '浏览器不兼容通知', { confirmButtonText: '确定' });
            } else {
                next();
            }
        }
    }
});
function setRem() {
    // 1920 默认大小16px; 1920px = 120rem ;每个元素px基础上/16
    const screenWidth = 1920
    const scale = screenWidth / 16
    const htmlWidth = document.documentElement.clientWidth || document.body.clientWidth
    // 得到html的Dom元素
    const htmlDom = document.getElementsByTagName('html')[0]
    // 设置根元素字体大小
    htmlDom.style.fontSize = htmlWidth / scale + 'px'
}
Vue.prototype.$setRem = setRem
// 初始化
setRem()
// 改变窗口大小时重新设置 rem
window.addEventListener('resize', function() {
    setRem();
});
router.afterEach(() => {
    NProgress.done();
});

window.vue = new Vue({ el: '#app', store, router, components: { App }, template: '<App/>' });
