import Vue from 'vue';
import Vuex from 'vuex';
import createPersistedState from "vuex-persistedstate"

Vue.use(Vuex);

const store = new Vuex.Store({
	state: {
		keepAliveList: [],
		homeFlag:true, //判断是否是首页，true则是首页，false则是进入管理后台

		// 2时，证明是运营数字化，则左侧菜单应该为：运营中心；
		// 3时，证明是移动设备安全，则左侧菜单应该为：数据中心；
		power_type:'', 
		userMsg:{},
		menuList:[],
		menuHeaderFlag: true
	},
	mutations: {
		setMenuHeaderFlag(state, data){
			state.menuHeaderFlag = data;
		},
		setHomePage(state, data) {
			state.homeFlag = data;
		},
		setPowerType(state, data){
			state.power_type = data;
		},
		setUserMsg(state, data){
			state.userMsg = JSON.parse(decodeURIComponent(data));	
		},
		setMenuList(state, data){
			state.menuList = data
		},
		setKeepAliveList(state, data) {
			var list = state.keepAliveList || [];
			if(!data.page){ return ; }
			if(data.type == 'add'&&state.keepAliveList.indexOf(data.page) == -1){
			    state.keepAliveList.push(data.page)	
			} else if(data.type == 'del'){
				state.keepAliveList = state.keepAliveList.filter(v => v !== data.page)
			} else if(data.type == 'set'){
				state.keepAliveList = data.page
			}
		}
	},
	modules: {},
	plugins: [createPersistedState({
		reducer(val){
			return {
                homeFlag: val.homeFlag,
				power_type: val.power_type,
				userMsg: val.userMsg,
				menuList: val.menuList
            }
		}
	})],
});

export default store;
