(function(global, factory, undefined) {
    global.tools = factory();
})(window, function() {
    var tools = window.tools || {};
    var doc = document;

    tools.get = function(Url, data, back, head) {
        var async = true;
        var method = data.method || "GET";
        var postData = "";
        if (method == "GET") {
            Url += "?";
            for (var i in data) {
                Url += i + "=" + data[i] + "&";
            }
            Url = Url.substr(0, Url.length - 1);
        } else {
            postData = tools.postDataFormat(data.data);
        }

        var xhr = new XMLHttpRequest();
        xhr.open(method, Url, async);
        xhr.timeout = 30000;
        head &&
            head.forEach(function(v) {
                xhr.setRequestHeader(v.key, v.value);
            });
        // 不支持FormData的浏览器的处理
        if (typeof FormData == "undefined") {
            xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        }
        xhr.onreadystatechange = function() {
            if (xhr.readyState == 4) {
                if (xhr.status == 200) {
                    back && back(xhr.response);
                } else {
                    console.log("请求失败" + xhr.status);
                }
            }
        };
        // xhr.onprogress = function(event) {
        //    console.log(event);
        //   }
        xhr.send(postData);
    };
    tools.checkVersion = function(back) {
        tools.get(window.location.origin + window.routeDir + "/static/version.json", { t: ~new Date() }, function(data) {
            var obj = JSON.parse(data);
            back && back(obj);
        });
    };
    tools.downFileByPost = function(url, params) {
        //params是post请求需要的参数，url是请求url地
        var iframe = document.createElement("iframe");
        iframe.id = "down_frame";
        iframe.name = "down_frame";
        iframe.style.display = "none";
        document.body.appendChild(iframe);

        var form = document.createElement("form");
        form.action = url;
        form.method = "post";
        form.target = "down_frame";
        form.style.display = "none";
        document.body.appendChild(form);
        // 动态创建input并给value赋值
        for (var key in params) {
            var input = document.createElement("input");
            input.type = "hidden";
            input.name = key;
            input.value = params[key];
            form.appendChild(input);
        }

        form.submit();
        form.remove();
        var vm = this;
        iframe.onload = function() {
            //如果url和网址跨域则取不到值
            var response = JSON.parse(iframe.contentWindow.document.querySelector("body").innerText);
            vm.$message({
                type: "warning",
                message: response.result.errorMsg
            });
            iframe.remove();
        };
    };
    tools.deepClone = function(source) {
        var targetObj = source.constructor === Array ? [] : {}; // 判断复制的目标是数组还是对象
        for (var keys in source) {
            // 遍历目标
            if (source.hasOwnProperty(keys)) {
                if (source[keys] && typeof source[keys] === "object") {
                    // 如果值是对象，就递归一下
                    targetObj[keys] = source[keys].constructor === Array ? [] : {};
                    targetObj[keys] = this.deepClone(source[keys]);
                } else {
                    // 如果不是，就直接赋值
                    targetObj[keys] = source[keys];
                }
            }
        }
        return targetObj;
    };
    // tools.$exportExcel = function(table, name) { //低版本excel 报文件格式和扩展名不匹配 todo
    // 	var template = 'data:application/vnd.ms-excel;base64,' + btoa(unescape(encodeURIComponent('<html xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:x="urn:schemas-microsoft-com:office:excel" xmlns="http://www.w3.org/TR/REC-html40"><head><!--[if gte mso 9]><xml><x:ExcelWorkbook><x:ExcelWorksheets><x:ExcelWorksheet><x:Name>{worksheet}</x:Name><x:WorksheetOptions><x:DisplayGridlines/></x:WorksheetOptions></x:ExcelWorksheet></x:ExcelWorksheets></x:ExcelWorkbook></xml><![endif]--></head><body><table>' + table + '</table></body></html>')));
    // 	var a = document.createElement('a');
    // 	a.href = template;
    // 	a.download = name + '.xls';
    // 	var evt = document.createEvent("MouseEvents");
    // 	evt.initEvent("click", false, false);
    // 	a.dispatchEvent(evt);
    // }
    return tools;
});
