/*
 * Author: Liu Ninggang
 * File Created: Monday, 27th September 2021 10:28:13 am
 * Last Modified: Wednesday, 29th September 2021 5:36:21 pm
 * Modified By: Liu Ninggang
 * Copyright (c) 2021 TP-LINK
 */

/* eslint-disable */

let inputBuffer;
let outputBuffer;
let has_init = 0;
let width, height;
let dataSeq;
var Module = {};

Module.onRuntimeInitialized = function() {
    Module._hevc_decoder_init();
    this.bufferLen = 2304 * 1296 * 8;
    inputBuffer = Module._malloc(this.bufferLen);
    outputBuffer = Module._malloc(this.bufferLen);
    width = Module._malloc(4);
    height = Module._malloc(4);
    has_init = 1;
    postMessage({ hasInit: true });
};

this.onmessage = function(event) {
    let { cmd } = event.data;
    if (cmd === 'init') {
        let { scripts, wasmBinary } = event.data;
        Module.wasmBinary = wasmBinary;
        self.importScripts(...scripts);
        return;
    }

    if (!has_init) return;

    if (cmd == 'decode') {
        let chunk = new Uint8Array(event.data.data);
        let { code_type, pts, timestamp, seq } = event.data;
        Module.HEAP8.set(chunk, inputBuffer);
        if (seq) {
            dataSeq = seq;
        }

        let len = Module._hevc_to_yuv(code_type, inputBuffer, chunk.length, outputBuffer, width, height);
        if (len > 0) {
            let data1 = Module.HEAPU8.subarray(width, width + 4);
            let result_width = data1[0] + data1[1] * 256;
            let data2 = Module.HEAPU8.subarray(height, height + 4);
            let result_height = data2[0] + data2[1] * 256;

            let outArray = Module.HEAPU8.subarray(outputBuffer, outputBuffer + len);
            let outputData = new Uint8Array(outArray);
            if (dataSeq) {
                seq = dataSeq;
                dataSeq = 0;
            }
            postMessage({ data: outputData.buffer, pts: pts, width: result_width, height: result_height, timestamp, seq }, [outputData.buffer]);
        }
    }
};
